summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
-rwxr-xr-xsrc/v4l2/libcamerify.in47
-rw-r--r--src/v4l2/meson.build11
2 files changed, 58 insertions, 0 deletions
diff --git a/src/v4l2/libcamerify.in b/src/v4l2/libcamerify.in
new file mode 100755
index 00000000..c4ea273f
--- /dev/null
+++ b/src/v4l2/libcamerify.in
@@ -0,0 +1,47 @@
+#!/bin/sh
+# SPDX-License-Identifier: GPL-2.0-or-later
+
+help() {
+ echo "$0: Load an application with libcamera V4L2 compatibility layer preload"
+ echo " $0 [OPTIONS...] executable [args]"
+ echo " -d, --debug Increase log level"
+}
+
+debug=0
+while [ $# -gt 0 ]; do
+ case $1 in
+ -d|--debug)
+ debug=$((debug+1))
+ ;;
+ -h)
+ help;
+ exit 0
+ ;;
+ --)
+ shift;
+ break;;
+ -*)
+ echo "Unrecognised option: $1";
+ help;
+ exit 1
+ ;;
+ *)
+ break
+ ;;
+ esac
+ shift
+done
+
+[ $debug -gt 0 ] && loglevel=V4L2Compat:0
+[ $debug -gt 1 ] && loglevel=0
+[ "$loglevel" != "" ] && export LIBCAMERA_LOG_LEVELS=$loglevel
+
+if [ "$LD_PRELOAD" = "" ] ; then
+ LD_PRELOAD='@LIBCAMERA_V4L2_SO@'
+else
+ LD_PRELOAD="$LD_PRELOAD "'@LIBCAMERA_V4L2_SO@'
+fi
+
+export LD_PRELOAD
+
+exec "$@"
diff --git a/src/v4l2/meson.build b/src/v4l2/meson.build
index f78497b6..f132103c 100644
--- a/src/v4l2/meson.build
+++ b/src/v4l2/meson.build
@@ -33,3 +33,14 @@ v4l2_compat = shared_library('v4l2-compat',
install : true,
dependencies : [libcamera_private, libdl],
cpp_args : v4l2_compat_cpp_args)
+
+# Provide a wrapper script to support easily loading applications with the V4L2
+# adaptation layer.
+
+cdata = configuration_data()
+cdata.set('LIBCAMERA_V4L2_SO', get_option('prefix') / get_option('libdir') / 'v4l2-compat.so')
+
+configure_file(input : 'libcamerify.in',
+ output : 'libcamerify',
+ configuration : cdata,
+ install_dir : get_option('bindir'))